

CAGrid = class()

function CAGrid:init(rows, cols)
    self.rows = rows
    self.cols = cols
    self.cells = self:createGrid(rows, cols)
end

function CAGrid:createGrid(rows, cols)
    local grid = {}
    for i = 1, rows do
        grid[i] = {}
        for j = 1, cols do
            grid[i][j] = 0  -- Initial state, can be adjusted as needed
        end
    end
    return grid
end

function CAGrid:getCell(row, col, wrap)
    if wrap then
        -- Wrap the row and column if they go out of bounds
        local wrappedRow = ((row - 1) % self.rows) + 1
        local wrappedCol = ((col - 1) % self.cols) + 1
        return self.cells[wrappedRow][wrappedCol]
    else
        -- Return nil if the cell is out of bounds, no wrapping
        if row >= 1 and row <= self.rows and col >= 1 and col <= self.cols then
            return self.cells[row][col]
        else
            return nil
        end
    end
end
